// BAS f - setMissionConditions
// Version: 0-0-2 (2008-01-18)
// Author(s): Fer
// ====================================================================================

// DECLARE VARIABLES AND FUNCTIONS

private ["_MissionTime","_MissionOvercast","_MissionFog"];

// ====================================================================================

// SET KEY VARIABLE
// Conditions are set using the value of f_var_Param1. Usually, f_var_Param1 == Param1.

f_var_Param1 = Param1;

// ====================================================================================

// SELECT MISSION CONDITIONS
// Using the value of f_var_Param1, new values for _MissionTime, _MissionOvercast and
// _MissionFog are set.

switch (f_var_Param1) do
{
// Noon | Clear
	case 1:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Noon | Overcast
	case 2:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Noon | Storm
	case 3:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Noon | Light Fog
	case 4:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Noon | Heavy Fog
	case 5:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================

// Dusk | Clear
	case 6:
	{
		setDate [2007, 5, 11, 19, 15];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Dusk | Overcast
	case 7:
	{
		setDate [2007, 5, 11, 19, 15];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Dusk | Storm
	case 8:
	{
		setDate [2007, 5, 11, 19, 15];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Dusk | Light Fog
	case 9:
	{
		setDate [2007, 5, 11, 19, 15];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Dusk | Heavy Fog
	case 10:
	{
		setDate [2007, 5, 11, 19, 15];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================

// Night | Clear
	case 11:
	{
		setDate [2007, 5, 11, 0, 0];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Night | Overcast
	case 12:
	{
		setDate [2007, 5, 11, 0, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Night | Storm
	case 13:
	{
		setDate [2007, 5, 11, 0, 0];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Night | Light Fog
	case 14:
	{
		setDate [2007, 5, 11, 0, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Night | Heavy Fog
	case 15:
	{
		setDate [2007, 5, 11, 0, 0];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================

// Dawn | Clear
	case 16:
	{
		setDate [2007, 5, 11, 4, 30];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Dawn | Overcast
	case 17:
	{
		setDate [2007, 5, 11, 4, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Dawn | Storm
	case 18:
	{
		setDate [2007, 5, 11, 4, 30];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Dawn | Light Fog
	case 19:
	{
		setDate [2007, 5, 11, 4, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Dawn | Heavy Fog
	case 20:
	{
		setDate [2007, 5, 11, 4, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================
	
// Early Morning | Clear
	case 21:
	{
		setDate [2007, 5, 11, 5, 30];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Early Morning | Overcast
	case 22:
	{
		setDate [2007, 5, 11, 5, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Early Morning | Storm
	case 23:
	{
		setDate [2007, 5, 11, 5, 30];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Early Morning | Light Fog
	case 24:
	{
		setDate [2007, 5, 11, 5, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Early Morning | Heavy Fog
	case 25:
	{
		setDate [2007, 5, 11, 5, 30];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================

// Morning | Clear
	case 26:
	{
		setDate [2007, 5, 11, 6, 45];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Morning | Overcast
	case 27:
	{
		setDate [2007, 5, 11, 6, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Morning | Storm
	case 28:
	{
		setDate [2007, 5, 11, 6, 45];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Morning | Light Fog
	case 29:
	{
		setDate [2007, 5, 11, 6, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Morning | Heavy Fog
	case 30:
	{
		setDate [2007, 5, 11, 6, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================

// Afternoon | Clear
	case 31:
	{
		setDate [2007, 5, 11, 15, 45];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Afternoon | Overcast
	case 32:
	{
		setDate [2007, 5, 11, 15, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Afternoon | Storm
	case 33:
	{
		setDate [2007, 5, 11, 15, 45];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Afternoon | Light Fog
	case 34:
	{
		setDate [2007, 5, 11, 15, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Afternoon | Heavy Fog
	case 35:
	{
		setDate [2007, 5, 11, 15, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================
	
// Evening | Clear
	case 36:
	{
		setDate [2007, 5, 11, 17, 45];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
// Evening | Overcast
	case 37:
	{
		setDate [2007, 5, 11, 17, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.10;
	};
// Evening | Storm
	case 38:
	{
		setDate [2007, 5, 11, 17, 45];
		_MissionOvercast = 01.00;
		_MissionFog = 00.50;
	};
// Evening | Light Fog
	case 39:
	{
		setDate [2007, 5, 11, 17, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.8125;
	};
// Evening | Heavy Fog
	case 40:
	{
		setDate [2007, 5, 11, 17, 45];
		_MissionOvercast = 00.60;
		_MissionFog = 00.96;
	};

// ====================================================================================
	
// Debug Mode
	case 99:
	{
		setDate [2007, 5, 11, 12, 0];
		_MissionOvercast = 00.00;
		_MissionFog = 00.00;
	};
};

// ====================================================================================

// SET MISSION CONDITIONS
// Use new values for _MissionTime, _MissionOvercast and _MissionFog to set
// mission conditions on server and all clients (including JIP clients).

skipTime _MissionTime;
0 setOvercast _MissionOvercast;
0 setFog _MissionFog;

// DEBUG
if (f_var_debugMode == 1) then
{
	player sideChat format ["DEBUG (f\common\f_setMissionConditions.sqf): _MissionTime: %1",_MissionTime];
	player sideChat format ["DEBUG (f\common\f_setMissionConditions.sqf): _MissionOvercast: %1",_MissionOvercast];
	player sideChat format ["DEBUG (f\common\f_setMissionConditions.sqf): _MissionFog: %1",_MissionFog];
};

// ====================================================================================

if (true) exitWith {};